#!/bin/sh
sync; echo 3 > /proc/sys/vm/drop_caches
#定义环境变量，需要改为服务器上的jdk地址
export JAVA_HOME=/usr/java/jdk1.8.0_131
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin:$JAVA_HOME/bin
export CLASSPATH=$JAVA_HOME/lib:$JAVA_HOME/lib/tools.jar
export PATH=$PATH:$JAVA_HOME/bin

date=`date +%Y%m%d%H%M%S`
#定义tomcat路径,需要改成服务器上tomcat的路径
tomcat_path=/usr/local/tomcat/apache-tomcat-7.0.104
#获取当前的tomcat进程id
TomcatID=$(ps -ef |grep tomcat |grep -w ${tomcat_path}|grep -w 'org.apache.catalina.startup.Bootstrap'|grep -v 'grep'|awk '{print $2}')

#定义tomcat启动的位置
StarTomcat=${tomcat_path}/bin/startup.sh
#定义tomcat停止的位置
StopTomcat=${tomcat_path}/bin/shutdown.sh
#定义需要重跑索引目录的目录名，目录名中间用空格隔开
#例：/data/project_index/gclx/index 这里取index上级目录名
pro_name="gclx hyxb hyxbywb"
read -a str <<< "$pro_name"
#定义需要备份的索引目录
bak_Path=/data/project_index/${str[0]}/index
bak_Path1=/data/project_index/${str[1]}/index
bak_Path2=/data/project_index/${str[2]}/index
#备份文件夹
bak_Dir=/rerun_index_temp/index_${str[0]}_${date}
bak_Dir1=/rerun_index_temp/index_${str[1]}_${date}
bak_Dir2=/rerun_index_temp/index_${str[2]}_${date}
#定义脚本日志路径
restart_tomcatLog=${tomcat_path}/rerun_index/restart-tomcat.log

Restart()
{
#判断tomcat进程是否存在
if [[ ${TomcatID} ]];then
   echo "[info]:tomcat进程id为[${TomcatID}]" 
   echo "即将停止tomcat"
   ${StopTomcat}
   TomcatID2=$(ps -ef |grep tomcat |grep -w ${tomcat_path}|grep -w 'org.apache.catalina.startup.Bootstrap'|grep -v 'grep'|awk '{print $2}')
   if [ ${TomcatID} -eq ${TomcatID2} ];then
      echo "tomcat进程存在，进程id为${TomcatID2}"       
      kill -9 ${TomcatID2}
      sleep 5
      echo kill -9 ${TomcatID2}
      sleep 5 
      echo "移动索引目录" 
      mv ${bak_Path} ${bak_Dir}
      mv ${bak_Path1} ${bak_Dir1}
      mv ${bak_Path2} ${bak_Dir2}
      echo "移动成功，开始创建新的索引目录"
      mkdir -p ${bak_Path}
      mkdir -p ${bak_Path1}
      mkdir -p ${bak_Path2}
      echo "创建成功，开始启动tomcat"
      ${StarTomcat} 
      else
      echo "移动索引目录" 
      mv ${bak_Path} ${bak_Dir}
      mv ${bak_Path1} ${bak_Dir1}
      mv ${bak_Path2} ${bak_Dir2}
      echo "移动成功，开始创建新的索引目录"
      mkdir -p ${bak_Path}
      mkdir -p ${bak_Path1}
      mkdir -p ${bak_Path2}
      echo "创建成功，开始启动tomcat"
      ${StarTomcat}
   fi
   else
   echo "tomcat进程不存在" 
   echo "移动索引目录" 
   mv ${bak_Path} ${bak_Dir}
   mv ${bak_Path1} ${bak_Dir1}
   mv ${bak_Path2} ${bak_Dir2}
   echo "移动成功，开始创建新的索引目录"
   mkdir -p ${bak_Path}
   mkdir -p ${bak_Path1}
   mkdir -p ${bak_Path2}
   echo "创建成功，开始启动tomcat"
   echo "${StarTomcat}"
   ${StarTomcat}
fi

echo "-------------${date}------------------"
}

Restart>>${restart_tomcatLog}

find /rerun_index_temp/ -name "index_*" -type d -mtime +3 |xargs rm -rf {} \;

echo "重启任务完成"

